#include "OutlookReader.h"

// CEnumOutlookEvent

class CEnumOutlookEvent :
	public IEnumMoraeEvent
{
public:
	CEnumOutlookEvent(	CArray<LPBYTE>& arrayData,
								COutlookReader* pReader,
								bool bAllEvents,
								INT_PTR nArrayIndex = 0,
								INT_PTR nDataPtrIndex = 0,
								UINT nCurrentCount = 0 );
protected:
	~CEnumOutlookEvent(void);

public:
	// Implementation of IUnknown
	virtual HRESULT __stdcall QueryInterface( const IID& iid, void** ppI );
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();

	// Implementation of IEnumMoraeEvent
	virtual HRESULT __stdcall Next( ULONG nCount, IMoraeEvent** ppIMoraeEvent, ULONG* pFetched );
	virtual HRESULT __stdcall Clone( IEnumMoraeEvent** ppIEnumMoraeEvent );
	virtual HRESULT __stdcall Skip( ULONG nCount );
	virtual HRESULT __stdcall Reset( void );

protected:
	CArray<LPBYTE>             m_arrayDataPtr;
	COutlookReader*				m_pReader;
	LONG                       m_nRefCount;// reference counter
	INT_PTR                    m_nDataArrayIndex;
	INT_PTR                    m_nDataPtrIndex;
	UINT                       m_nCurrentCount;// Record count into current data file
	bool                       m_bAllEvents;	// true if this enumerator is referring to all
															// events in the stream.  This determines the
															// interpretation of m_arrayDataPtr

	bool GetNextRecord( LPVOID* ppData, LPDWORD pdwSize );
};