#pragma once

class COutlookReader;

class COutlookEvent :
	public IMoraeSearchableEvent
{
public:
	COutlookEvent( LPVOID pData, 
		DWORD dwBytes, 
		COutlookReader* pReader );
protected:
	~COutlookEvent(void);

public:
	// Override of IUnknown implementation
	virtual HRESULT __stdcall QueryInterface( const IID& iid, void** ppI );
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();

	// Implementation of IMoraeEvent
	virtual HRESULT __stdcall GetTime( VARIANT* pVarET, VARIANT* pVarTimeDate );
	virtual HRESULT __stdcall GetTimeRange( VARIANT* pVarStartTimes, VARIANT* pVarEndTimes );
	virtual HRESULT __stdcall GetAppTag( int* pTag );
	virtual HRESULT __stdcall GetWndClassTag( int* pTag );
	virtual HRESULT __stdcall GetHWND( VARIANT* pVar );
	virtual HRESULT __stdcall GetEventTypeID( UUID* pID );

	// Implementation of IMoraeSearchableEvent
	virtual HRESULT __stdcall GetAttributeString( LCID localeID, int nColID, BSTR* pbstrAttr );
	virtual HRESULT __stdcall GetItemRectangle( int* pLeft, int* pTop, int* pRight, int* pBottom );

protected:
	LONG m_nRefCount;// reference counter
	LPVOID m_pData;
	DWORD m_dwDataBytes;
	COutlookReader* m_pReader;

	bool GetEventTypeString( BSTR* pbstrEventName );
};
