// CrossStreamSearchDlg.cpp : Implementation of CCrossStreamSearchDlg

#include "stdafx.h"
#include "OutlookReaderDlg.h"
#include "dllmain.h"


COutlookReaderDlg::COutlookReaderDlg()
{
}

COutlookReaderDlg::~COutlookReaderDlg()
{
}

bool COutlookReaderDlg::UpdateDlgFromSearchParameters()
{
   if ( ::IsWindow( m_hWnd ) )
   {
      // TODO: LEA wrap these in a try block since they can throw - but what to catch?
      CheckDlgButton( IDC_CK_SEND, m_searchParameters.bSend );
      CheckDlgButton( IDC_CK_READ, m_searchParameters.bRead );
      return true;
   }

   return false;
}

bool COutlookReaderDlg::UpdateSearchParametersFromDlg()
{
   if ( ::IsWindow( m_hWnd ) )
   {
      UINT unChecked = IsDlgButtonChecked( IDC_CK_SEND );
      m_searchParameters.bSend = ( unChecked == BST_CHECKED );
      unChecked = IsDlgButtonChecked( IDC_CK_READ );
      m_searchParameters.bRead = ( unChecked == BST_CHECKED );

      return true;
   }

   return false;
}

void COutlookReaderDlg::SetSearchParameters( const SOutlookReaderCfg& rParams )
{
   m_searchParameters = rParams;
}

const SOutlookReaderCfg& COutlookReaderDlg::GetSearchParameters() const
{
   return m_searchParameters;
}

// 
// COutlookReaderDlg - message handlers
// 
LRESULT COutlookReaderDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
   CAxDialogImpl<COutlookReaderDlg>::OnInitDialog(uMsg, wParam, lParam, bHandled);

   // load up the initial state
   UpdateDlgFromSearchParameters();

   bHandled = TRUE;
   return 1;  // Let the system set the focus
}

LRESULT COutlookReaderDlg::OnClickedOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
   // save off any changes
   UpdateSearchParametersFromDlg();
   EndDialog(wID);

   return 0;
}

LRESULT COutlookReaderDlg::OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
   EndDialog(wID);
   return 0;
}

LRESULT COutlookReaderDlg::OnClickedHelp(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
   EndDialog(wID);
   return 0;
}