// OutlookReaderDlg.h : Declaration of the COutlookReaderDlg

#pragma once

#include "resource.h"       // main symbols

#include <atlhost.h>
#include <string>

struct SOutlookReaderCfg
{
   BOOL bSend;
   BOOL bRead;
};

// COutlookReaderDlg

class COutlookReaderDlg : 
   public CAxDialogImpl<COutlookReaderDlg>
{
private:
   SOutlookReaderCfg m_searchParameters;

   bool  UpdateDlgFromSearchParameters();
   bool  UpdateSearchParametersFromDlg();
   bool  UpdateEnabledState() const;
   UINT  GetDlgItemText( int nID, std::wstring& strText ) const;

public:
   COutlookReaderDlg();
   ~COutlookReaderDlg();

   enum { IDD = IDD_OUTLOOKREADERDLG };

   BEGIN_MSG_MAP(CCrossStreamSearchDlg)
      MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
      COMMAND_HANDLER(IDOK, BN_CLICKED, OnClickedOK)
      COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
      COMMAND_HANDLER(IDC_BN_HELP, BN_CLICKED, OnClickedHelp)
      CHAIN_MSG_MAP(CAxDialogImpl<COutlookReaderDlg>)
   END_MSG_MAP()

   void  SetSearchParameters( const SOutlookReaderCfg& rParams );
   const SOutlookReaderCfg& GetSearchParameters() const;

   // Handler prototypes:

   LRESULT OnInitDialog( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled );
   LRESULT OnClickedOK( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );
   LRESULT OnClickedCancel( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );
   LRESULT OnClickedHelp( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );
};