// dllmain.cpp : Implementation of DllMain.

#include "stdafx.h"
#include "resource.h"
#include "OutlookReader_i.h"
#include "dllmain.h"

COutlookReaderModule _AtlModule;

// initialize static members
HINSTANCE COutlookReaderModule::m_hInstance = NULL;
CComBSTR  COutlookReaderModule::m_bstrHelpPath = NULL;


// implement static functions
unsigned int COutlookReaderModule::LoadString( CComBSTR& rStr, int nStringID )
{
   try
   {
      rStr.Empty();
      if ( rStr.LoadString( COutlookReaderModule::GetInstance(), nStringID ) )
         return rStr.Length();
   }
   catch (...)
   {
   }

   return 0;
}

bool COutlookReaderModule::GenerateHelpPath()
{
   if ( m_bstrHelpPath.Length() )
      return true;   // we already have the help path

   if ( m_hInstance )
   {
      wchar_t moduleName[_MAX_PATH + 1] = { L'\0' };
      DWORD dwSize = ::GetModuleFileNameW( m_hInstance, moduleName, _MAX_PATH );
      if ( dwSize > 0 && dwSize < (_MAX_PATH - wcslen( L"chm" )) )
      {
         // find the extension, replace it with chm
         for ( DWORD dwPos = dwSize - 1; dwPos > 0; --dwPos )
         {
            if ( moduleName[dwPos] == L'.' )
            {
               // set the new extension
               moduleName[dwPos + 1] = L'c';
               moduleName[dwPos + 2] = L'h';
               moduleName[dwPos + 3] = L'm';
               moduleName[dwPos + 4] = L'\0';

               // set the help file name
               m_bstrHelpPath = moduleName;
               ATLASSERT( m_bstrHelpPath.Length() == wcslen(moduleName) );
               return true;
            }
         }
      }
   }

   return false;
}

void COutlookReaderModule::HtmlHelp( DWORD_PTR dwData, UINT nCmd )
{
   // if we have a length, assume we've been set correctly
   if ( m_bstrHelpPath.Length() )
      ::HtmlHelp( ::GetDesktopWindow(), m_bstrHelpPath, nCmd, dwData );
}

// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
#ifdef _MERGE_PROXYSTUB
   if (!PrxDllMain(hInstance, dwReason, lpReserved))
      return FALSE;
#endif
   hInstance;
   return _AtlModule.DllMain(dwReason, lpReserved); 
}