﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace OutlookAddIn1
{
   //public enum SetupStatus
   //{
   //   Setup_Ready = 1,
   //   Setup_Incomplete = 2,
   //};

   //// Enumeration of calibration requirements for GetCalibrationRequirements
   //public enum CalibReq
   //{
   //   Calib_Never = 0x00000000,
   //   Calib_OneTime = 0x00000001,
   //   Calib_EachRecording = 0x00000002,
   //   Calib_EachStartup = 0x00000004,
   //};

   //// Enumeration of calibration states for GetCalibStatus
   //public enum CalibStatus
   //{
   //   Calib_Ready = 1,
   //   Calib_Needed = 2,
   //};

   //// Enumeration of capture control values for CaptureControl
   //public enum CaptureControl
   //{
   //   Capture_Idle = 0,
   //   Capture_Start = 1,
   //   Capture_Stop = 2,
   //   Capture_Pause = 3,
   //   Capture_Resume = 4,
   //};

   [Guid( "78F72AF2-41A0-47F3-B753-6139A9849708" )]
   [InterfaceType( ComInterfaceType.InterfaceIsIUnknown )]
   [ComImport]
   public interface IEventCap
   {

      [PreserveSig]
      System.UInt32 GetName(
                                 [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStr,
                                 [In]long nLocaleID );

      [PreserveSig]
      System.UInt32 GetDescription(
                                 [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStr,
                                 [In]long nLocaleID );

      [PreserveSig]
      System.UInt32 HasSetupDialog(
                                 [In, Out, MarshalAs( UnmanagedType.VariantBool )]ref bool pBool );

      [PreserveSig]
      System.UInt32 HasCalibrationDialog(
                                 [In, Out, MarshalAs( UnmanagedType.VariantBool )]ref bool pBool );

      [PreserveSig]
      System.UInt32 GetSetupStatus(
                                 [In, Out, MarshalAs( UnmanagedType.I4 )]ref SetupStatus pStatus );

      [PreserveSig]
      System.UInt32 GetCalibrationStatus(
                                 [In, Out, MarshalAs( UnmanagedType.I4 )]ref CalibStatus pStatus );

      [PreserveSig]
      System.UInt32 GetCalibrationRequirements(
                                 [In, Out, MarshalAs( UnmanagedType.U4 )]ref System.UInt32 pCalReq );

      [PreserveSig]
      System.UInt32 GetCaptureParameters(
                                 [In, Out, MarshalAs( UnmanagedType.Struct )]ref Array pVarParam );

      [PreserveSig]
      System.UInt32 SetCaptureParameters(
                                 [In, MarshalAs( UnmanagedType.Struct )]Array varParam );

      [PreserveSig]
      System.UInt32 GetCalibrationParameters(
                                 [In, Out, MarshalAs( UnmanagedType.Struct )]ref Array pVarParam );

      [PreserveSig]
      System.UInt32 SetCalibrationParameters(
                                 [In, MarshalAs( UnmanagedType.Struct )]Array varParam );

      [PreserveSig]
      System.UInt32 SetOutputDirectory(
                                 [In, MarshalAs( UnmanagedType.BStr )]string strDir );

      [PreserveSig]
      System.UInt32 GetOutputFilenames(
                                 [In, Out, MarshalAs( UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_BSTR )]ref Array parNames );

      [PreserveSig]
      System.UInt32 ShowSetupDialog(
                                 [In, MarshalAs( UnmanagedType.Struct )]int varHwndParent,
                                 [In, MarshalAs( UnmanagedType.I4 )]int nLocaleID );

      [PreserveSig]
      System.UInt32 ShowCalibrationDialog(
                                 [In, MarshalAs( UnmanagedType.Struct )]int varHwndParent,
                                 [In]int nLocaleID );

      [PreserveSig]
      System.UInt32 SetCaptureRect(
                                 [In]int nTop,
                                 [In]int nBottom,
                                 [In]int nLeft,
                                 [In]int nRight );

      [PreserveSig]
      System.UInt32 ControlCapture(
                                 CaptureControl nCmd );

      [PreserveSig]
      System.UInt32 GetEventReaderID(
                                 [In, Out]ref Guid puuidID );
   }

   [Guid( "3360F8DF-9A5C-4de0-B229-96CBA443F0CE" )]
   class EventCaptureInternal : IEventCap
   {
      protected string strOutDir;
      private CaptureControl captureStatus = CaptureControl.Capture_Idle;

      public System.UInt32 GetName( [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStr,
                          [In]long nLocaleID )
      {
         // TODO: Use locale
         pStr = "OutlookPlugin";
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetDescription(
                              [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStr,
                              [In]long nLocaleID )
      {
         return 0x80004001;// VSConstants.E_NOTIMPL;
      }

      public System.UInt32 HasSetupDialog(
                                 [In, Out, MarshalAs( UnmanagedType.VariantBool )]ref bool pBool )
      {
         pBool = false;
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 HasCalibrationDialog(
                                 [In, Out, MarshalAs( UnmanagedType.VariantBool )]ref bool pBool )
      {
         pBool = false;
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetSetupStatus(
                                 [In, Out, MarshalAs( UnmanagedType.I4 )]ref SetupStatus pStatus )
      {
         pStatus = SetupStatus.Setup_Ready;
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetCalibrationStatus(
                                 [In, Out, MarshalAs( UnmanagedType.I4 )]ref CalibStatus pStatus )
      {
         pStatus = CalibStatus.Calib_Ready;
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetCalibrationRequirements(
                                 [In, Out, MarshalAs( UnmanagedType.U4 )]ref System.UInt32 pCalReq )
      {
         pCalReq = (System.UInt32)CalibReq.Calib_Never;
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetCaptureParameters(
                                 [In, Out, MarshalAs( UnmanagedType.Struct )]ref Array pVarParam )
      {
         return 0x00000001;// VSConstants.S_FALSE;
      }

      public System.UInt32 SetCaptureParameters(
                                 [In, MarshalAs( UnmanagedType.Struct )]Array varParam )
      {
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetCalibrationParameters(
                                 [In, Out, MarshalAs( UnmanagedType.Struct )]ref Array pVarParam )
      {
         return 0x00000001;// VSConstants.S_FALSE;
      }

      public System.UInt32 SetCalibrationParameters(
                                 [In, MarshalAs( UnmanagedType.Struct )]Array varParam )
      {
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 SetOutputDirectory(
                                 [In, MarshalAs( UnmanagedType.BStr )]string strDir )
      {
         strOutDir = strDir;
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetOutputFilenames(
                                 [In, Out, MarshalAs( UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_BSTR )]ref Array parNames )
      {
         return 0x80000000;// VSConstants.E_FAIL;
      }

      public System.UInt32 ShowSetupDialog(
                                 [In, MarshalAs( UnmanagedType.Struct )]int varHwndParent,
                                 [In, MarshalAs( UnmanagedType.I4 )]int nLocaleID )
      {
         return 0x00000001;// VSConstants.S_FALSE;
      }

      public System.UInt32 ShowCalibrationDialog(
                                 [In, MarshalAs( UnmanagedType.Struct )]int varHwndParent,
                                 [In]int nLocaleID )
      {
         return 0x00000001;// VSConstants.S_FALSE;
      }

      public System.UInt32 SetCaptureRect(
                                 [In]int nTop,
                                 [In]int nBottom,
                                 [In]int nLeft,
                                 [In]int nRight )
      {
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 ControlCapture(
                                 CaptureControl nCmd )
      {
         // TODO: figure out how to call some event handler
         captureStatus = nCmd;
         return 0;// VSConstants.S_OK;
      }

      public System.UInt32 GetEventReaderID(
                                 [In, Out]ref Guid puuidID )
      {
         return 0x80004001;// VSConstants.E_NOTIMPL;
      }

      public CaptureControl GetCaptureStatus()
      {
         return captureStatus;
      }
   }
}
