﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using Microsoft.VisualStudio;
using System.Collections.Specialized;

namespace MoraeEventCapture
{
   public class CaptureStatusEventArgs : EventArgs
   {
      public CaptureControl captureCmd;
   }

   public delegate void CaptureStatusChanged( object sender, CaptureStatusEventArgs e );

   [Guid( "718348DB-C619-44A7-8291-B081E8BE3B54" )]
   [ComVisible( true )]
   public class OutlookEventCapture : EventCaptureWrapper
   {
      protected string strOutDir;
      protected StringCollection arOutputPaths = new StringCollection();

      private CaptureControl captureStatus = CaptureControl.Capture_Idle;

      public event CaptureStatusChanged eventCaptureStatus;

      override public System.Int32 GetName( [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStr,
                          [In]Int32 nLocaleID )
      {
         // TODO: Use localeID
         pStr = OutlookAddIn1.Properties.Resources.name;
         return VSConstants.S_OK;
      }

      override public System.Int32 GetDescription(
                              [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStr,
                              [In]Int32 nLocaleID )
      {
         // TODO: Use localeID
         pStr = OutlookAddIn1.Properties.Resources.description;
         return VSConstants.S_OK;
      }

      override public System.Int32 HasSetupDialog(
                                 [In, Out, MarshalAs( UnmanagedType.VariantBool )]ref bool pBool )
      {
         pBool = false;
         return VSConstants.S_OK;
      }

      override public System.Int32 SetOutputDirectory(
                                 [In, MarshalAs( UnmanagedType.BStr )]string strDir )
      {
         strOutDir = strDir;
         return VSConstants.S_OK;
      }

      override public System.Int32 GetOutputFilepaths(
                                 [In, Out, MarshalAs( UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_BSTR )]ref String[] parNames )
      {
         parNames = new String[arOutputPaths.Count];
         for ( int i = 0; i < arOutputPaths.Count; i++ )
         {
            parNames.SetValue( arOutputPaths[i], i );
         }

         return VSConstants.S_OK;
      }

      override public System.Int32 ShowSetupDialog(
                                 [In, MarshalAs( UnmanagedType.Struct )]Object varHwndParent,
                                 [In]Int32 nLocaleID )
      {
         // Just for testing of error handling in Recorder
         //throw new System.ArithmeticException();
         //unsafe
         //{
         //   int* pInt = null;
         //   *pInt = 1;
         //}
         return VSConstants.S_FALSE;
      }
      //   // No setup dialog is needed for this plugin

      //   ///////////////////////////////////////////////////////////////////////////////////////////
      //   // This code is an example of how to use the HWND that is supplied by the caller
      //   OutlookAddIn1.CWin32Wrapper parent;
      //   if ( varHwndParent is long )
      //   {
      //      parent = new OutlookAddIn1.CWin32Wrapper( (long)varHwndParent );
      //   }
      //   else if ( varHwndParent is int )
      //   {
      //      parent = new OutlookAddIn1.CWin32Wrapper( (long)( (int)varHwndParent ) );
      //   }
      //   else if ( varHwndParent is UInt64 )
      //   {
      //      parent = new OutlookAddIn1.CWin32Wrapper( (long)( (UInt64)varHwndParent ) );
      //   }
      //   else if ( varHwndParent is UInt32 )
      //   {
      //      parent = new OutlookAddIn1.CWin32Wrapper( (long)( (UInt32)varHwndParent ) );
      //   }
      //   else
      //   {
      //      parent = new OutlookAddIn1.CWin32Wrapper( (long)0 );
      //   }
      //   string msg = "No setup dialog is available";
      //   System.Windows.Forms.MessageBox.Show( parent, msg );
      //   ///////////////////////////////////////////////////////////////////////////////////////////


      //   return VSConstants.S_FALSE;
      //}

      override public System.Int32 ControlCapture(
                                 [In]int nCmd,
                                 [In]UInt32 nTime )
      {
         CaptureStatusEventArgs e = new CaptureStatusEventArgs();
         e.captureCmd = (CaptureControl)nCmd;
         captureStatus = (CaptureControl)nCmd;
         if ( eventCaptureStatus != null )
         {
            eventCaptureStatus( this, e );
         }
         return VSConstants.S_OK;
      }

      override public System.Int32 GetEventReaderInfo(
                                 [In, Out]ref Guid puuidID,
                                 [In, Out]ref UInt32 pnMajorVersion,
                                 [In, Out]ref UInt32 pnMinorVersion,
                                 [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStrHandlerName,
                                 [In, Out, MarshalAs( UnmanagedType.BStr )]ref string pStrURL,
                                 [In]Int32 nLocaleID )
      {
         // This GUID needs to coincide with the GUID of the event handler that reads
         // the file generated by this plugin.
         puuidID = new Guid("F22417E1-5E19-4de2-B0A4-EC321C747DB2");
         pnMajorVersion = 0x00010000;
         pnMinorVersion = 0x00000000;
         pStrHandlerName = "Outlook Event Reader";
         pStrURL = "www.techsmith.com";
         return VSConstants.S_OK;
      }

      // Not part of IEventCapture
      public CaptureControl GetCaptureStatus()
      {
         return captureStatus;
      }

      public string GetOutputDirectory()
      {
         return strOutDir;
      }

      public void ClearOuputPaths()
      {
         arOutputPaths.Clear();
      }

      public void AddOutputPath( string strPath )
      {
         arOutputPaths.Add( strPath );
      }
   }
}
