﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace OutlookAddIn1
{
   // This Guid is IID_IPluginManager
   [ComImport,
      Guid( "3F4E295C-0935-4ACC-B00A-B37F13DDE85F" ), 
      InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
   interface IPluginManager
   {
      //[PreserveSig] 
      void RegisterComponent(
                              [In, MarshalAs( UnmanagedType.BStr )]string strName,
                              [In]ref Guid clsidHelper,
                              [In]ref Guid clsidRecorder );
      //[PreserveSig] 
      void UnregisterComponent(
                              [In, MarshalAs( UnmanagedType.BStr )]string strName,
                              [In]ref Guid clsidHelper,
                              [In]ref Guid clsidRecorder );

      //[PreserveSig]
      void AddEventSource(
                              [In, MarshalAs( UnmanagedType.IUnknown)]Object pSource,
                              [In]UInt32 nProcessID,
                              [In]ref Guid clsidRecorder );

      //[PreserveSig]
      void RemoveEventSource(
                              [In, MarshalAs(UnmanagedType.IUnknown)]Object pSource,
                              [In]UInt32 nProcessID,
                              [In]ref Guid clsidRecorder );
   }

   // Declare RecHelperManager as a COM coclass:
   // This Guid is CLSID_PluginManager, the identifier of the object that 
   // RecorderCaptureHelper.exe exposes.
   [ComImport, Guid( "1F3E87EE-B5EC-46B3-8A6E-F08A2F5F27AE" )]
   class RecHelperManager // Cannot have a base class or
   // interface list here.
   {
      // Cannot have any members here 
      // NOTE that the C# compiler will add a default constructor
      // for you (no parameters).
   }

}
