﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace OutlookAddinInstaller
{
   class Program
   {
      static void Main(string[] args)
      {
         // Initialize the GUIDs that define this object.
         // This is the GUID that we want Morae Recorder to use when it is asking for
         // this object.  When we call IPluginManager::AddEventSource, this is what we
         // pass to it.
         Guid guidRec = new Guid("A4CC7F43-9E4D-47e0-AE42-502C655E881E");
         // This is the GUID that IPluginManager recognizes as this object.  We have to tell
         // IPluginManager about this GUID in the call to IPluginManager::RegisterComponent
         // and IPluginManager::UnregisterComponent.  (These methods should only be called
         // when this component is registered or unregistered during installation.) 
         // Note that this GUID matches the Guid attribute of EventCaptureWrapper.
         Guid guidHelper = new Guid("718348DB-C619-44a7-8291-B081E8BE3B54");
         
         IPluginManager recHelper;
         try
         {
            RecHelperManager recCOM = new RecHelperManager();
            recHelper = (IPluginManager)recCOM;

            Console.WriteLine( "Press i to install or u to uninstall." );
            ConsoleKeyInfo strCmd = Console.ReadKey();

            Console.WriteLine();

            // If uninstall flag was passed in command line
            if ( strCmd.KeyChar == 'u' )
            {
               Console.WriteLine( "Uninstalling Outlook Plugin..." );
               recHelper.UnregisterComponent( "OutlookPlugin", ref guidHelper, ref guidRec );
               Console.WriteLine( "Done." );
            }
            else
            {
               Console.WriteLine( "Installing Outlook Plugin..." );
               recHelper.RegisterComponent( "OutlookPlugin", ref guidHelper, ref guidRec );
               Console.WriteLine( "Done." );
            }
         }
         catch ( System.Runtime.InteropServices.COMException ex )
         {
            HandleCOMException( ex );
         }
         catch ( System.Runtime.InteropServices.SEHException ex )
         {
            HandleCOMException( ex );
         }
         catch ( System.NotImplementedException ex )
         {
            HandleCOMException( ex );
         }
         catch ( System.AccessViolationException ex )
         {
            HandleCOMException( ex );
         }
         catch ( System.UnauthorizedAccessException ex )
         {
            HandleCOMException( ex );
         }
         finally
         {
            Console.WriteLine( "Press any key to exit." );
            Console.ReadKey();
         }
      }

      static void HandleCOMException(Object objException)
      {
         Console.WriteLine(objException.ToString());
      }
   }
}
