// OutlookAddinSetup.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "RecorderCaptureHelper_i.h"
#include <atlbase.h>
#include <iostream>
#include <conio.h>

using namespace std;

EXTERN_C const CLSID CLSID_PluginManager;
EXTERN_C const IID IID_IRecPluginMgr;

// 325BBAB8-98F2-44af-85BD-383A6FD97C99
static const GUID GUID_OUTLOOK_PLUGIN_HELPER = 
{ 0x325BBAB8, 0x98F2, 0x44af, { 0x85, 0xBD, 0x38, 0x3A, 0x6F, 0xD9, 0x7C, 0x99 } };


// 6EA26F89-81AF-4a98-9AA1-C73DF667CD5C
static const GUID GUID_OUTLOOK_PLUGIN_REC = 
{ 0x6EA26F89, 0x81AF, 0x4a98, { 0x9A, 0xA1, 0xC7, 0x3D, 0xF6, 0x67, 0xCD, 0x5C } };

int _tmain(int argc, _TCHAR* argv[])
{
   CoInitialize( NULL );
   // Place ComPtrs in brackets so they out of scope
   // This is necessary to call CoUninitialize
   {
      CComPtr<IUnknown> pUnk = NULL;
      CComPtr<IPluginManager> pMgr = NULL;
      
      HRESULT hRes = ::CoCreateInstance( CLSID_PluginManager, NULL, CLSCTX_LOCAL_SERVER | CLSCTX_INPROC_SERVER,
                                          IID_IUnknown/*IID_IRecPluginMgr*/,  (void**) &pUnk );
      if ( SUCCEEDED(hRes) )
      {
         hRes = pUnk->QueryInterface( IID_IPluginManager, (void**)&pMgr );
         if ( SUCCEEDED(hRes) )
         {
            char cCmd;
            cout << "Press i to install or u to uninstall.\n";
            cCmd = _getch();

            CComBSTR strName( _T("OutlookPlugin") );
            if ( cCmd == 'u' || cCmd == 'U' )
            {
               hRes = pMgr->UnregisterComponent( strName, GUID_OUTLOOK_PLUGIN_HELPER, GUID_OUTLOOK_PLUGIN_REC );
               if ( SUCCEEDED(hRes) )
                  cout << "Successfully uninstalled Outlook Plug-in\n";
               else
                  cout << "Failed to uninstall Outlook Plug-in\n";
            }
            else
            {
               hRes = pMgr->RegisterComponent( strName, GUID_OUTLOOK_PLUGIN_HELPER, GUID_OUTLOOK_PLUGIN_REC );
               if ( SUCCEEDED(hRes) )
                  cout << "Successfully installed Outlook Plug-in\n";
               else
                  cout << "Failed to install Outlook Plug-in\n";
            }
         }
         else
         {
            cout << "QueryInterface call to IRecPluginMgr to create IPluginManager failed.\n";         
         }
      }
      else
      {
         cout << "CoCreateInstance call failed to create IRecPluginMgr.\n";
      }

      _getch();
   }

   CoUninitialize();
	return 0;
}